# Apress Source Code and Appendix

This repository accompanies [*The Common Lisp Condition System*](https://itbook.store/books/9781484261330) by Michał "phoe" Herda (Apress, 2020).

[comment]: #cover
![Cover image](9781484261330.jpg)

The sources are split into sources for the first part of the book and the appendices (the [`Sources - TCLCS`](Sources%20-%20TCLCS/) folder) and sources for Portable Condition System (PCS, the [`Sources - PCS`](Sources%20-%20PCS/) folder). Note that the sources for PCS are for version 1.1.0 of the library and will not be updated here; for contributing to PCS, please see [the main repository of the project](https://github.com/phoe/portable-condition-system).

The [`Appendix E`](Appendix%20E) folder contains **Appendix E - Discussing the Common Lisp Condition System**, an online-only appendix that contains additional material for Chapter 4 of the book that did not make it into the final text due to time constraints.

Download the files as a zip using the green button, or clone the repository to your machine using Git.

## Online discussions about the book

* [2020-07-15 - Hacker News](https://news.ycombinator.com/item?id=23843525)
* [2020-10-23 - Hacker News](https://news.ycombinator.com/item?id=24867548)

(If you're aware of any other discussions, please feel free to make a PR and add it.)

## Releases

Release v1.0 corresponds to the code in the published book, without corrections or updates.

## License

The source code for TCLCS is licensed under the CC0 license and placed in the public domain.

The source code for Portable Condition System is licensed under the CC0 license and placed in the public domain, except for the test suite, which is licensed under the MIT license. Please see the `README` and `LICENSE` files in the respective subfolders of this repository for details.

Appendix E as a whole is licensed under the CC0 license and placed in the public domain.

## Contributions

See the file [Contributing.md](Contributing.md) for more information on how you can contribute to this repository.
